/* eslint-disable */
/**柯礼钦
 * 4/3/2020, 3:00:49 PM
 * doc comment for the file goes here
 */

/** 表单搜索组件 */
import React, { ReactNode, ReactEventHandler, Component } from 'react';
import { Row, Col, Form, Input, Button, Select, DatePicker, Divider, Card } from 'antd';
import moment from 'moment';

const { RangePicker, MonthPicker } = DatePicker;
import './index.scss';

// data参数：数据模板
// [
//     { type: 'input', name: '姓名', label: '姓名', key: 'name' },  //inpu类型
//     {
//         type: 'select',
//         name: '所属部门',
//         label: '所属部门',
//         key: 'deptId',
//         desc: 'deptName',
//         list: [{ name: '1', value: '选项1' }, { name: '2', value: '选项2' }],
//     }, //select 类型
//     {
//         type: 'rangePicker',
//         label: '时间范围',
//         name: JSON.stringify(['开始时间', '结束时间']),
//         key: JSON.stringify(['startTime', 'endTime']),
//         keylistName: 'rangeTimelist',
//     },  //时间范围选择器
//     {
//         type: 'datePicker',
//         label: '指定时间',
//         name: '指定日期',
//         key: 'date'
//     } //时间选择器
// ]
export default class SearchFormView extends Component {
    constructor(props) {
        super(props);
        this.config = {
        };
        this.state = {
        };
    }

    componentWillMount() { }

    componentDidMount() { }

    onClick = type => {
        let data;
        switch (type) {
            case 'search':
                data = { ...this.props.formData, __key: Date.now() };
                this.props.setFormData(data);
                return;
            case 'reset':
                data = { __key: Date.now(), page: 1, size: 10 };
                this.props.setFormData(data);
                return;
            case 'build':
                return;
        }
    };

    //各类型表单元素触发事件
    // input输入类型
    handleInput = ({ target: { name, value } }) => {
        this.props.setFormData({ ...this.props.formData, [name]: value });
    };

    // select下拉选择
    handleSelectChange = name => {
        return value => {
            this.handleInput({ target: { name, value } });
        };
    };

    // 时间段区域选择
    rangePickerChange = (name, key, m, d) => {
        if (m.length > 0) {
            this.props.setFormData({
                ...this.props.formData,
                [name]: d.join(','),
                [JSON.parse(key)[0]]: d[0],
                [JSON.parse(key)[1]]: d[1],
            });
        } else {
            this.props.setFormData({
                ...this.props.formData,
                [name]: undefined,
                [JSON.parse(key)[0]]: '',
                [JSON.parse(key)[1]]: '',
            });
        }
    };

    // 时间选择器
    datePickerChange = (name, v) => {
        this.props.setFormData({
            ...this.props.formData,
            [name]: v,
        });
    };

    //月份选择器
    monthPickerChange = (name, m, d) => {
        this.props.setFormData({
            ...this.props.formData,
            [name]: d
        })
    }

    render() {
        const { formData = {}, data = [], children, width = "25%", showReset = true } = this.props;
        let size = 'default';

        return (
            <div className="search-form-view-main">
                <div className="search-form-view-main-margin-bottom">
                    <Card bordered={false}>

                        {data.length > 0 &&
                            data.map((item, idx) => (
                                <Card.Grid key={idx} style={{ width }} hoverable={false} >
                                    {(() => {
                                        switch (item.type) {
                                            case 'select':
                                                return (
                                                    <Form.Item label={item.label}>
                                                        <Select
                                                            size={size}
                                                            style={{ width: '100%' }}
                                                            placeholder={item.name}
                                                            value={formData[item.key]}
                                                            // allowClear
                                                            onChange={this.handleSelectChange(item.key)}>
                                                            {item.list &&
                                                                item.list.map(item => (
                                                                    <Select.Option
                                                                        value={item.value}
                                                                        key={item.value}>
                                                                        {item.name}
                                                                    </Select.Option>
                                                                ))}
                                                        </Select>
                                                    </Form.Item>
                                                );
                                            case 'input':
                                                return (
                                                    <Form.Item label={item.label}>
                                                        <Input
                                                            size={size}
                                                            placeholder={item.name}
                                                            name={item.key}
                                                            value={formData[item.key]}
                                                            onChange={this.handleInput}
                                                        />
                                                    </Form.Item>
                                                );
                                            case 'datePicker':
                                                return (
                                                    <Form.Item label={item.label}>
                                                        <DatePicker
                                                            size={size}
                                                            style={{ width: '100%' }}
                                                            placeholder={item.name}
                                                            onChange={(date, dateString) => {
                                                                this.datePickerChange(item.key, dateString);
                                                            }}
                                                            value={formData[item.key] ? moment(formData[item.key], 'YYYY-MM-DD') : undefined}
                                                        />
                                                    </Form.Item>
                                                );
                                            case 'rangePicker':
                                                return (
                                                    <Form.Item label={item.label}>
                                                        <RangePicker
                                                            style={{ width: '100%' }}
                                                            size={size}
                                                            ranges={{
                                                                Today: [moment(), moment()],
                                                                'This Month': [
                                                                    moment().startOf('month'),
                                                                    moment().endOf('month'),
                                                                ],
                                                            }}
                                                            value={
                                                                item.keylistName &&
                                                                    formData[item.keylistName] &&
                                                                    typeof formData[item.keylistName] == 'string'
                                                                    ? formData[item.keylistName]
                                                                        .split(',')
                                                                        .map(item => moment(item, 'YYYY-MM-DD'))
                                                                    : []
                                                            }
                                                            onChange={(date, dateString) => {
                                                                this.rangePickerChange(
                                                                    item.keylistName,
                                                                    item.key,
                                                                    date,
                                                                    dateString
                                                                );
                                                            }}
                                                            placeholder={JSON.parse(item.name)}
                                                        />
                                                    </Form.Item>
                                                );
                                            case 'monthPicker':
                                                return (
                                                    <Form.Item label={item.label}>
                                                        <MonthPicker
                                                            style={{ width: '100%' }}
                                                            size={size}
                                                            placeholder={item.name}
                                                            onChange={(date, dateString) => {
                                                                console.log(date, dateString);
                                                                this.monthPickerChange(item.key, date, dateString);
                                                            }}
                                                            value={formData[item.key] ? moment(formData[item.key], 'YYYY-MM') : undefined}
                                                        />
                                                    </Form.Item>

                                                )
                                            // case 'br':
                                            //     return (
                                            //         <Col span={24} style={{ marginBottom: '10px' }} />
                                            //     );
                                            default:
                                                return null;
                                        }
                                    })()}
                                </Card.Grid>
                            ))}
                        <Card.Grid style={{ width }}>
                            <Row type="flex" gutter={20} align="middle" align="middle" style={{ height: 40 }}>
                                <Col>
                                    <Button
                                        size={size}
                                        type="primary"
                                        onClick={() => {
                                            this.onClick('search');
                                        }}>
                                        查询
                                </Button>
                                </Col>
                                {
                                    showReset ?
                                        <Col>
                                            <Button
                                                size={size}
                                                onClick={() => {
                                                    this.onClick('reset');
                                                }}>
                                                重置
                                            </Button>
                                        </Col> : null
                                }
                                {
                                    children &&
                                    <Col>
                                        {children}
                                    </Col>
                                }
                            </Row>
                        </Card.Grid>
                    </Card>
                </div>
                <Divider />
            </div>
        )
    }
}
